defs.in 2.7 KB
Newer Older
1
# -*- mode: shell-script; coding: utf-8 -*-
2 3
# Copyright (C) 2009, 2010, 2012, 2013, 2015 Laboratoire de Recherche
# et Développement de l'Epita (LRDE).
Guillaume Sadegh's avatar
Guillaume Sadegh committed
4
# Copyright (C) 2003, 2004, 2006 Laboratoire d'Informatique de Paris 6 (LIP6),
5
# département Systèmes Répartis Coopératifs (SRC), Université Pierre
Alexandre Duret-Lutz's avatar
Alexandre Duret-Lutz committed
6 7 8 9 10 11
# et Marie Curie.
#
# This file is part of Spot, a model checking library.
#
# Spot is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
12
# the Free Software Foundation; either version 3 of the License, or
Alexandre Duret-Lutz's avatar
Alexandre Duret-Lutz committed
13 14 15 16 17 18 19 20
# (at your option) any later version.
#
# Spot is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
# License for more details.
#
# You should have received a copy of the GNU General Public License
21
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
22 23 24 25 26 27 28

# Ensure we are running from the right directory.
test -f ./defs || {
   echo "defs: not found in current directory" 1>&2
   exit 1
}

29
# If srcdir is not set, then we are not running from `make check'.
30 31 32 33 34 35 36 37 38 39 40 41 42 43
if test -z "$srcdir"; then
   # compute $srcdir.
   srcdir=`echo "$0" | sed -e 's,/[^\\/]*$,,'`
   test $srcdir = $0 && srcdir=.
fi

# Ensure $srcdir is set correctly.
test -f $srcdir/defs.in || {
   echo "$srcdir/defs.in not found, check \$srcdir" 1>&2
   exit 1
}

echo "== Running test $0"

44 45 46 47 48 49 50 51
me=`echo "$0" | sed -e 's,.*[\\/],,;s/\.test$//'`

testSubDir=$me.dir
chmod -R a+rwx $testSubDir > /dev/null 2>&1
rm -rf $testSubDir > /dev/null 2>&1
mkdir $testSubDir
cd $testSubDir

52 53 54
# Adjust srcdir now that we are in a subdirectory.  We still want
# $srcdir to point to the source directory corresponding to the build
# directory that contains $testSubDir.
55 56 57 58 59
case $srcdir in
  [\\/$]* | ?:[\\/]* );;
  *) srcdir=../$srcdir
esac

60
DOT='@DOT@'
61
top_builddir='../@top_builddir@'
62 63
LBTT="@LBTT@"
LBTT_TRANSLATE="@LBTT_TRANSLATE@"
64
VALGRIND='@VALGRIND@'
65 66
SPIN='@SPIN@'
LTL2BA='@LTL2BA@'
67
PYTHON='@PYTHON@'
68
top_srcdir='../@top_srcdir@'
69

70 71 72 73
# The test cases assume these variable are undefined
unset SPOT_DOTEXTRA
unset SPOT_DOTDEFAULT

74 75 76 77 78 79
need_lbtt()
{
  # LBTT may not have been installed or compiled.
  ("$LBTT" --version) || exit 77
}

80 81 82 83 84 85 86 87
run()
{
  expected_exitcode=$1
  shift
  exitcode=0
  if test -n "$VALGRIND"; then
    exec 6>valgrind.err
    GLIBCPP_FORCE_NEW=1 \
88
    ../../libtool --mode=execute \
89
    $VALGRIND --tool=memcheck --leak-check=yes --log-fd=6 -q "$@" ||
90
      exitcode=$?
91 92 93 94
    cat valgrind.err 1>&2
    test -z "`sed 1q valgrind.err`" || exit 50
    rm -f valgrind.err
  else
95
    "$@" || exitcode=$?
96 97 98
  fi
  test $exitcode = $expected_exitcode || exit 1
}
99

100
set -x